
package de.ivu.elect.presentation.email.table;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.email.entity.Email;
import de.ivu.elect.jee.presentation.dynamictable.AbstractColumnBuilder;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;
import de.ivu.elect.presentation.person.PersonendatenFormatter;
import de.ivu.elect.presentation.person.table.PersonendatenFamiliennameAnzeigeColumn;
import de.ivu.elect.presentation.person.table.PersonendatenRufnameAnzeigeColumn;

@Named(EmailColumnBuilder.COMPONENT_NAME)
public class EmailColumnBuilder extends AbstractColumnBuilder<Email> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailColumnBuilder";

  @Inject
  private transient PersonendatenFormatter personendatenFormatter;

  private AbstractEmailColumn<Email> emailStatusColumn;

  private AbstractEmailColumn<Email> emailAnhaengeColumn;

  private AbstractEmailColumn<Email> emailEmpfaengerColumn;

  private AbstractEmailColumn<Email> emailPersonendatenFamiliennameAnzeigeColumn;

  private AbstractEmailColumn<Email> emailPersonendatenRufnameAnzeigeColumn;

  private AbstractEmailColumn<Email> emailFehlermeldungColumn;

  private AbstractEmailColumn<Email> emailAnzahlSendeversucheColumn;

  private AbstractEmailColumn<Email> emailZeitpunktLetzterSendeversuchColumn;

  public EmailColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    emailStatusColumn = new EmailStatusColumn<>(getMessages(), getIcons());

    emailAnhaengeColumn = new EmailAnhaengeColumn<>(getMessages(), getIcons());

    emailEmpfaengerColumn = new EmailEmpfaengerColumn<>(getMessages());

    emailPersonendatenFamiliennameAnzeigeColumn = new EmailPersonendatenColumn(getMessages(), new PersonendatenFamiliennameAnzeigeColumn<>(getMessages(), personendatenFormatter));
    emailPersonendatenRufnameAnzeigeColumn = new EmailPersonendatenColumn(getMessages(), new PersonendatenRufnameAnzeigeColumn<>(getMessages(), personendatenFormatter));

    emailFehlermeldungColumn = AbstractEmailColumn.createEmailFehlermeldungColumn(getMessages());

    emailAnzahlSendeversucheColumn = AbstractEmailColumn.createEmailAnzahlSendeversucheColumn(getMessages());

    emailZeitpunktLetzterSendeversuchColumn = AbstractEmailColumn.createEmailLetzterSendeversuchColumn(getMessages());
  }

  @Override
  protected List<ColumnEntry< ? super Email>> getColumnEntriesSorted() {
    List<ColumnEntry< ? super Email>> result = new ArrayList<>();

    result.add(emailStatusColumn);

    result.add(emailAnhaengeColumn);

    result.add(emailEmpfaengerColumn);

    result.add(emailPersonendatenFamiliennameAnzeigeColumn);
    result.add(emailPersonendatenRufnameAnzeigeColumn);

    result.add(emailFehlermeldungColumn);

    result.add(emailAnzahlSendeversucheColumn);

    result.add(emailZeitpunktLetzterSendeversuchColumn);

    return result;
  }
}
